program ex2
use mpi
implicit none
integer :: err,procs,rank,in,out
call MPI_Init(err)
call MPI_Comm_size(MPI_COMM_WORLD,procs,err)
call MPI_Comm_rank(MPI_COMM_WORLD,rank,err)
out = rank
if (rank.eq.0) then
    call MPI_Sendrecv(out,1,MPI_INT,rank+1,17, &
                      in,1,MPI_INT,procs-1,18, &
                      MPI_COMM_WORLD,MPI_STATUS_IGNORE,err)
elseif (rank.eq.procs-1) then
    call MPI_Sendrecv(out,1,MPI_INT,0,17,      &
                      in,1,MPI_INT,rank-1,18,  &
                      MPI_COMM_WORLD,MPI_STATUS_IGNORE,err)
else
    call MPI_Sendrecv(out,1,MPI_INT,rank+1,17, &
                      in,1,MPI_INT,rank-1,18,  &
                      MPI_COMM_WORLD,MPI_STATUS_IGNORE)
endif
if (rank.eq.0) then
   print *,"rank 0 received", in
endif
call MPI_Finalize(err)
end program ex2
