program ex5f
  use omp_lib
  implicit none

  integer :: i,sum,n,m

  print *,"Hello!"

  i = 7;
  sum = 0;
  !$omp parallel shared(i) reduction(+:sum) private(n,m)
  n = omp_get_num_threads()
  m = omp_get_thread_num()
  call work(m,n)
  !$omp master
  i = 9;
  !$omp end master
  sum=sum+i;
  !$omp end parallel
  print *, "result=",sum

contains

subroutine work(thread, numthreads)
  implicit none
  integer :: thread, numthreads, n, m, t
  n = numthreads
  m = thread
  t = abs(n/2-abs(n/4-m))
  call sleep(t)
end subroutine work

end program ex5f
