program ex3
  use mpi
  implicit none

  integer      :: procs, rank, ierr, left, right
  real(kind=8) :: d

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD,procs,ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD,rank,ierr)
  left=mod(rank+procs-1,procs)
  right=mod(rank+1,procs)
  d=rank*1.1d0
  call MPI_Ssend(d,1,MPI_DOUBLE,right,17,MPI_COMM_WORLD,ierr)
  call MPI_Recv(d,1,MPI_DOUBLE,left,17,MPI_COMM_WORLD,MPI_STATUS_IGNORE)
  call MPI_Finalize(ierr)

end program ex3


