#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <unistd.h>

void work(int thread, int numthreads);

int main() {
   
   printf("Hello!\n");

   int i = 7;
   int sum = 0;
   #pragma omp parallel shared(i) reduction(+:sum)
   {
      int n = omp_get_num_threads();
      int m = omp_get_thread_num();
      work(m,n);
      #pragma omp master
      i = 9;
      sum+=i;
   }
   printf("result=%d\n", sum);
}

void work(int thread, int numthreads)
{
   int n = numthreads;
   int m = thread;
   int t = abs(n/2-abs(n/4-m));
   sleep(t);
}
